//Commision Calculator Engine
function commCalc() {
  var markup = document.getElementById('markup').value;
  var base = document.getElementById('base').value;
  if (markup=="" || base=="") {
  	if (markup!=="" && base=="") {
		  if (!isNumeric(markup)) {
		  	document.getElementById('markup').value = "";
		  	alphaMsg ();
		  } else {
	  		checkRate(markup, base);
		  }
  	}
  	if (markup=="" && base!=="") {
		  if (!isNumeric(base)) {
		  	document.getElementById('base').value = "";
		  	alphaMsg ();
		  } 
  	}
  } else if (markup!=="" && base!=="") {
	  if (!isNumeric(markup) || !isNumeric(base)) {
		  if (isNumeric(markup) && !isNumeric(base)) {
		  	document.getElementById('base').value = "";
				alphaMsg ();
		  }
		  if (!isNumeric(markup) && isNumeric(base)) {
		  	document.getElementById('markup').value = "";
		  	alphaMsg ();
		  }
		  } else {
	  	checkRate(markup, base);
	  }
	  //alert("markup is "+ markup +" base is "+ base);
  }
}

function alphaMsg (number) {
	document.getElementById('gross').innerHTML = "<span class='msg'>No Alpha Characters</span>";
	document.getElementById('comm').innerHTML = "$0.00";
	return (false);
}

function checkRate(markup, base) {
	var markup = Math.abs(markup);
	if (markup<=1000) {
		document.getElementById('markup').value = markup;
		checkBase(markup, base);
	} else {			
		document.getElementById('markup').value = "";
		document.getElementById('gross').innerHTML = "<span class='msg'>1000% Max Commission</span>";
		document.getElementById('comm').innerHTML = "Too much";
	}
}

function checkBase(markup, base) {
	var base = Math.abs(base);
	document.getElementById('base').value = base;
	doCommCalc(markup, base);
}

function doCommCalc(markup, base) {
  if (markup>=100) {
		var gross = Math.round ((base*markup)*100)/100;
		document.getElementById('gross').innerHTML=formatCurrency(gross);
		var comm = Math.round ((gross - base)*100)/100;
		document.getElementById('comm').innerHTML=formatCurrency(comm);
  } else {
		var gross = (base/(1-(markup/100)));
		document.getElementById('gross').innerHTML=formatCurrency(gross);
		var comm = (gross - base);
		document.getElementById('comm').innerHTML=formatCurrency(comm);
  }
}

//-------------------------------------------------------------------
// isNumeric(value)
//   Returns true if value contains a positive float value
//-------------------------------------------------------------------
function isNumeric(val) {
	return(parseFloat(val,10)==(val*1));
}

//Format number as U.S. currency
function formatCurrency(num)
{
	num = num.toString().replace(/\$|\,/g,'');
	if(isNaN(num))
		num = "0";
		sign = (num == (num = Math.abs(num)));
		num = Math.floor(num*100+0.50000000001);
		cents = num%100;
		num = Math.floor(num/100).toString();
	if(cents<10)
		cents = "0" + cents;
		for (var i = 0; i < Math.floor((num.length-(1+i))/3); i++)
		num = num.substring(0,num.length-(4*i+3))+','+
	num.substring(num.length-(4*i+3));
	return (((sign)?'':'-') + '$' + num + '.' + cents);
}


/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/


// Global variables for the info and done buttons; keeping these around lets us modify them later
var glassDoneButton;
var blackInfoButton;

// setup() is the onload handler for the widget. It calls constructors for the AppleInfoButton
// and AppleGlassButton classes that populate existing divs with their respective controls

/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

function setup()
{
	glassDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
	blackInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);

	if(window.widget)
	{
		var defaultMarkup = widget.preferenceForKey("defaultMarkup");

		if (defaultMarkup && defaultMarkup.length > 0)
		{											
			document.getElementById('markup').value = defaultMarkup;
		}
	}
}


function setPrefMarkup(elem)
{
	if(window.widget)
	{
  	  widget.setPreferenceForKey(elem,"defaultMarkup");
	}
}


// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}
